define(function () {
    /*
    Calls a function using named arguments rather than positional ones.
    */
    if (typeof Object.prototype.invoke !== "function") {
        var parameters = function (func) {
            if (!(func instanceof Function)) {
                throw new TypeError("Argument func must of type function.");
            }
            var m = /function[^\(]*\(([^\)]*)\)/.exec(f.toString());
            var params = m[1].split(',');
            var i;
            for (i = 0; i < params.length; i++) {
                params[i] = params[i].replace(/^\s*|\s*$/g, '');
            }
            return params;
        };
        /*
        TODO: check that this calls the function with the right context.
        */
        Function.prototype.invoke = function (ctxt, argObj) {
            var params = parameters(this);
            var argsArr = [];
            var i;
            for (i = 0; i < params.length; i++) {
                argsArr[i] = argsObj[params[i]] || null;
            }
            return this.apply(ctxt, argsArr);
        };
    }
    else {
        console.warn(
            "Function.prototype.invoke is either implemented in native code or has already been overriden."
        );
    }
    /*
    Returns a new object with the given object `o` as its prototype.
    */
    if (typeof Object.create !== "function") {
        Object.create = function (object) {
            function func () {};
            func.prototype = object;
            return new func();
        };
    }
    else {
        console.warn(
            "Object.create is either implemented in native code or has already been overriden."
        );
    }
});
